src/config/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

from students.views import index

urlpatterns = [
    path("__debug__/", include("debug_toolbar.urls")),
    path("", index, name="index"),
    path("admin/", admin.site.urls),
    path("students/", include("students.urls")),
    path("teachers/", include("teachers.urls")),
    path("groups/", include("groups.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/groups/urls.py
from django.urls import path
from groups.views import get_groups, create_group, update_group, delete_group, group_detail


app_name = "groups"

urlpatterns = [
    path("", get_groups, name="all_groups"),
    path("create/", create_group, name="create_group"),
    path("update/<int:pk>/", update_group, name="update_group"),
    path("delete/<int:pk>/", delete_group, name="delete_group"),
    path("group/<int:pk>/", group_detail, name="group_detail"),
]

src/groups/models.py
import random

from django.db import models
from faker import Faker


random = random.Random()


class Group(models.Model):
    group_name = models.CharField(max_length=120, blank=True)
    start_date = models.DateField(null=True, blank=True)
    cost = models.PositiveIntegerField(null=True, blank=True)
    amount_of_students = models.PositiveSmallIntegerField(null=True, blank=True)
    rating = models.PositiveSmallIntegerField(null=True, blank=True)
    description = models.CharField(max_length=300, null=True, blank=True)

    @classmethod
    def generate_instances(cls, count):
        fake = Faker()
        for _ in range(count):
            cls.objects.create(
                group_name=random.choice(
                    [
                        "Python Beginner",
                        "Python Pro",
                        "Java Beginner",
                        "Java Pro",
                        "JavaScript Beginner",
                        "JavaScript Pro",
                        "HR",
                        "Marketing",
                        "Python Testing",
                        "Java Testing",
                        "Design",
                    ]
                ),
                start_date=fake.date_this_year(before_today=False, after_today=True),
                cost=random.choice(["13999", "14999", "20999", "10999", "12999"]),
                amount_of_students=random.randint(10, 16),
                rating=random.randint(0, 5),
                description=fake.text(max_nb_chars=300),
            )

    def __str__(self):
        return (
            f"({self.pk}) {self.group_name} starts at {self.start_date}, costs {self.cost}₴. "
            f"Description: {self.description}"
        )

src/groups/forms.py
from django.forms import ModelForm

from groups.models import Group


class GroupForm(ModelForm):
    class Meta:
        model = Group
        fields = ["group_name", "start_date", "cost", "amount_of_students"]

    @staticmethod
    def normalize_text(text: str) -> str:
        return text.strip().capitalize()

    def clean_group_name(self):
        return self.normalize_text(self.cleaned_data["group_name"])

src/groups/views.py
from django.db.models import Q
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from webargs import fields
from webargs.djangoparser import use_args

from groups.forms import GroupForm
from groups.models import Group


@use_args(
    {
        "group_name": fields.Str(
            required=False,
        ),
        "start_date": fields.Str(
            required=False,
        ),
        "search": fields.Str(
            required=False,
        ),
    },
    location="query",
)
def get_groups(request, params):
    groups = Group.objects.all()

    search_fields = ["group_name", "start_date", "cost"]

    for param_name, param_value in params.items():
        if param_name == "search":
            or_filter = Q()
            for field in search_fields:
                or_filter |= Q(**{f"{field}__icontains": param_value})
            groups = groups.filter(or_filter)
        else:
            groups = groups.filter(**{param_name: param_value})

    return render(request, template_name="groups/group_list.html", context={"groups": groups})


def create_group(request):
    if request.method == "POST":
        form = GroupForm(request.POST)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect(reverse("groups:all_groups"))
    elif request.method == "GET":
        form = GroupForm(request.POST)

    return render(request, template_name="groups/group_create.html", context={"form": form})


def update_group(request, pk):
    group = get_object_or_404(Group.objects.all(), pk=pk)
    if request.method == "POST":
        form = GroupForm(request.POST, instance=group)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect(reverse("groups:all_groups"))
    elif request.method == "GET":
        form = GroupForm(instance=group)

    return render(request, template_name="groups/group_update.html", context={"form": form})


def delete_group(request, pk):
    group = get_object_or_404(Group.objects.all(), pk=pk)
    if request.method == "POST":
        group.delete()
        return HttpResponseRedirect(reverse("groups:all_groups"))
    elif request.method == "GET":
        pass

    return render(request, template_name="groups/group_delete.html", context={"group": group})


def group_detail(request, pk):
    group = get_object_or_404(Group.objects.all(), pk=pk)
    return render(request, "groups/group_detail.html", {"group": group})

src/templates/groups/group_create.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <form method="post" style="width: 25em; margin: auto">
            {% csrf_token %}
            {{ form|crispy }}
            <br>
            <button type="submit" class="btn btn-primary" value="Submit">Submit</button>
        </form>
    </div>
{% endblock content %}

src/templates/groups/group_delete.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <form method="post" style="width: 25em; margin: auto">
            {% csrf_token %}
            <p> Group {{ group.group_name }} will be deleted.</p>
            <br>
            <button type="submit" class="btn btn-danger" value="Delete">Delete</button>
        </form>
    </div>
{% endblock content %}

src/templates/groups/group_detail.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <table class="table table-dark table-striped">
            <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Group name</th>
                <th scope="col">Start date</th>
                <th scope="col">Cost</th>
                <th scope="col">Amount of students</th>
                <th scope="col">Rating</th>
                <th scope="col">Description</th>
            </tr>
            </thead>
            <tbody>
                <tr>
                    <th scope="row">{{ group.pk }}</th>
                    <td>{{ group.group_name }}</td>
                    <td>{{ group.start_date }}</td>
                    <td>{{ group.cost }}</td>
                    <td>{{ group.amount_of_students }}</td>
                    <td>{{ group.rating }}</td>
                    <td>{{ group.description }}</td>
                    <th>
                        <a type="button" class="btn btn-warning" href="{% url "groups:update_group" group.pk %}">Edit</a>
                    </th>
                    <th>
                        <a type="button" class="btn btn-danger" href="{% url "groups:delete_group" group.pk %}">Delete</a>
                    </th>
                </tr>
            </tbody>
        </table>
    </div>
{% endblock content %}


{% block header %}
<a class="nav-link" href="{% url 'groups:create_group' %}">Add new group</a>
{% endblock header %}

src/templates/groups/group_list.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <table class="table table-dark table-striped">
            <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Group name</th>
                <th scope="col">Start date</th>
                <th scope="col">Cost</th>
                <th scope="col">Amount of students</th>
                <th scope="col">Rating</th>
                <th scope="col">Description</th>
            </tr>
            </thead>
            <tbody>
            {% for group in groups %}
                <tr>
                    <th scope="row">{{ group.pk }}</th>
                    <td>{{ group.group_name }}</td>
                    <td>{{ group.start_date }}</td>
                    <td>{{ group.cost }}</td>
                    <td>{{ group.amount_of_students }}</td>
                    <td>{{ group.rating }}</td>
                    <td>{{ group.description }}</td>
                    <th>
                        <a type="button" class="btn btn-warning" href="{% url "groups:update_group" group.pk %}">Edit</a>
                    </th>
                    <th>
                        <a type="button" class="btn btn-danger" href="{% url "groups:delete_group" group.pk %}">Delete</a>
                    </th>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    </div>
{% endblock content %}


{% block header %}
<a class="nav-link" href="{% url 'groups:create_group' %}">Add new group</a>
{% endblock header %}

src/templates/groups/group_update.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <form method="post" style="width: 25em; margin: auto">
            {% csrf_token %}
            {{ form|crispy }}
            <br>
            <button type="submit" class="btn btn-primary" value="Update">Update</button>
        </form>
    </div>
{% endblock content %}